require('dotenv').config()
const assert = require('assert')
const _ = require('lodash')
const Faker = require('faker')
const process = require('process')
const path = require('path')
const target = process.env.NODE_ENV === 'production' ? 'dist' : 'libs'
const ClusterHandler = require(path.resolve(target, 'index.js'))
const message = Faker.random.word()
const worker = {
  id: Faker.random.number(),
  process: {
    pid: Faker.random.number()
  }
}
const address = {
  address: Faker.internet.ip(),
  port: Faker.random.number(),
  addressType: 'udp4'
}
const settings = {
  args: [Faker.random.word(), Faker.random.word()],
  exec: Faker.random.word(),
  silent: false,
  execArgv: [Faker.random.word(), Faker.random.word(), Faker.random.word()],
  stdio: [Faker.random.word(), Faker.random.word(), Faker.random.word(), Faker.random.word()],
  uid: Faker.random.number(),
  gid: Faker.random.number(),
  inspectPort: Faker.random.number()
}

/**
 *
 */
describe('TEST ClusterHandler', () => {
  it('GREEN: CASE1', done => {
    assert.strictEqual(_.isObjectLike(ClusterHandler.registerHandler()), true)
    done()
  })
  it('GREEN: CASE2', done => {
    assert.strictEqual(_.isEmpty(ClusterHandler.onMessage(worker, message)), true)
    done()
  })
  it('GREEN: CASE3', done => {
    assert.strictEqual(_.isEmpty(ClusterHandler.onWorkerMessage(worker, message)), true)
    done()
  })
  it('GREEN: CASE4', done => {
    assert.strictEqual(_.isEmpty(ClusterHandler.onMasterMessage(worker, message)), true)
    done()
  })
  it('GREEN: CASE5', done => {
    assert.strictEqual(_.isEmpty(ClusterHandler.onOnline(worker)), true)
    done()
  })
  it('GREEN: CASE6', done => {
    assert.strictEqual(_.isEmpty(ClusterHandler.onListening(worker, address)), true)
    done()
  })
  it('GREEN: CASE7', done => {
    assert.strictEqual(_.isEmpty(ClusterHandler.onSetup(settings)), true)
    done()
  })
  // these tests below are working but need to sent a lot of messages(SMS/EMAIL), need to pay money...
  // it('GREEN: CASE8', done => {
  //   assert.strictEqual(_.isEmpty(ClusterHandler.onExit(worker, Faker.random.number(), Faker.random.word())), true)
  //   done()
  // })
  // it('GREEN: CASE9', done => {
  //   assert.strictEqual(_.isEmpty(ClusterHandler.onDisconnect(worker)), true)
  //   done()
  // })
  // it('GREEN: CASE10', done => {
  //   assert.strictEqual(_.isEmpty(ClusterHandler.onDeath(worker)), true)
  //   done()
  // })
  // it('GREEN: CASE11', done => {
  //   assert.strictEqual(_.isEmpty(ClusterHandler.onError(message)), true)
  //   done()
  // })
})
